优选算法系列(4.前缀和 _下) k

目录

[五:和为 k 的子数组(medium)](#五:和为 k 的子数组(medium))

[题目链接:560. 和为 K 的子数组 - 力扣(LeetCode)](#题目链接:560. 和为 K 的子数组 - 力扣(LeetCode))

解法:

代码:

[六:和可被 K 整除的子数组(medium)](#六:和可被 K 整除的子数组(medium))

[题目链接:974. 和可被 K 整除的子数组 - 力扣(LeetCode)](#题目链接:974. 和可被 K 整除的子数组 - 力扣(LeetCode))

解法:

代码:

七:连续数组(medium)

[题目链接:525. 连续数组 - 力扣(LeetCode)](#题目链接:525. 连续数组 - 力扣(LeetCode))

解法:

代码:

八:矩阵区域和(medium)

[题目链接:1314. 矩阵区域和 - 力扣(LeetCode)](#题目链接:1314. 矩阵区域和 - 力扣(LeetCode))

解法:

代码:


五:和为 k 的子数组(medium)

题目链接:560. 和为 K 的子数组 - 力扣(LeetCode)

解法:

解法二(前缀和):

设 i 为数组中的任意位置,用sumi 表示 0, i 区间内所有元素的和。
想知道有多少个「以 i 为结尾的和为 k 的子数组」,就要找到有多少个起始位置为 x1, x2, x3... 使得 x, i 区间内的所有元素的和为 k 。那么 0, x 区间内的和是不是就是 sumi - k 了。
于是问题就变成:

  • 找到在 0, i - 1 区间内,有多少前缀和等于 sumi - k 的即可。


我们不用真的初始化⼀个前缀和数组,因为我们只关心在 i 位置之前,有多少个前缀和等于
sumi - k 。因此,我们仅需⽤⼀个哈希表,⼀边求当前位置的前缀和,⼀边存下之前每⼀种
前缀和出现的次数。

代码:

C++:

java:

六:和可被 K 整除的子数组(medium)

题目链接:974. 和可被 K 整除的子数组 - 力扣(LeetCode)


(本题是某一年的蓝桥杯竞赛原题)

解法:

前置知识:

  • 同余定理

如果 (a - b) % n == 0 ,那么我们可以得到⼀个结论: a % n == b % n 。⽤文字叙述就是,如果两个数相减的差能被 n 整除,那么这两个数对 n 取模的结果相同。
例如: (26 - 2) % 12 == 0 ,那么 26 % 12 == 2 % 12 == 2 。

  • c++ 中负数取模的结果,以及如何修正「负数取模」的结果

a. c++ 中关于负数的取模运算,结果是「把负数当成正数,取模之后的结果加上⼀个负号」。
例如: -1 % 3 = -(1 % 3) = -1
b. 因为有负数,为了防⽌发⽣「出现负数」的结果,以 (a % n + n) % n 的形式输出保证为正。
例如: -1 % 3 = (-1 % 3 + 3) % 3 = 2
算法思路:
思路与上道题的思路相似。
设 i 为数组中的任意位置,用 sumi 表示 0, i 区间内所有元素的和。
想知道有多少个「以 i 为结尾的可被 k 整除的子数组」,就要找到有多少个起始位置为 x1, x2, x3... 使得 x, i 区间内的所有元素的和可被 k 整除。
设 0, x - 1 区间内所有元素之和等于 a , 0, i 区间内所有元素的和等于 b ,可得
(b - a) % k == 0 。
由同余定理可得, 0, x - 1 区间与 0, i 区间内的前缀和同余。于是问题就变成:

  • 找到在 0, i - 1 区间内,有多少前缀和的余数等于 sumi % k 的即可。

我们不用真的初始化⼀个前缀和数组,因为我们只关心在 i 位置之前,有多少个前缀和等于
sumi - k 。因此,我们仅需用⼀个哈希表,⼀边求当前位置的前缀和,⼀边存下之前每⼀种前
缀和出现的次数。

代码:

C++:

java:

七:连续数组(medium)

题目链接:525. 连续数组 - 力扣(LeetCode)

解法:

稍微转化⼀下题目,就会变成我们熟悉的题:
本题让我们找出⼀段连续的区间, 0 和 1 出现的次数相同。
如果将 0 记为 -1 , 1 记为 1 ,问题就变成了找出⼀段区间,这段区间的和等于 0 。
于是,就和 560. 和为 K 的子数组 这道题的思路⼀样
设 i 为数组中的任意位置,⽤ sumi 表示 0, i 区间内所有元素的和。
想知道最⼤的「以 i 为结尾的和为 0 的子 0数1组」,就要找到从左往右第⼀个 x1 使得 x1, i
区间内的所有元素的和为 0 。那么 0, x1 - 1 区间内的和是不是就是 sumi 了。于是问题
就变成:
找到在 0, i - 1 区间内,第⼀次出现 sumi 的位置即可。
我们不⽤真的初始化⼀个前缀和数组,因为我们只关⼼在 i 位置之前,第⼀个前缀和等于 sumi
的位置。因此,我们仅需⽤⼀个哈希表,⼀边求当前位置的前缀和,⼀边记录第⼀次出现该前缀和的
位置。

代码:

C++:

java:

八:矩阵区域和(medium)

题目链接:1314. 矩阵区域和 - 力扣(LeetCode)

解法:

⼆维前缀和的简单应用题,关键就是我们在填写结果矩阵的时候,要找到原矩阵对应区域的「左上
角」以及「右下角」的坐标(推荐画图)

回顾:

左上⻆坐标: x1 = i - k,y1 = j - k ,但是由于会「超过矩阵」的范围,因此需要对 0 取⼀个 max 。因此修正后的坐标为: x1 = max(0, i - k), y1 = max(0, j - k) ;

右下⻆坐标: x1 = i + k,y1 = j + k ,但是由于会「超过矩阵」的范围,因此需要对 m - 1 ,以及 n - 1 取⼀个 min 。因此修正后的坐标为: x2 = min(m - 1, i + k) , y2 = min(n - 1, j + k) 。

然后将求出来的坐标代入到「二维前缀和矩阵」的计算公式上即可~(但是要注意下标的映射关
系)

代码:

C++:

java:

相关推荐
pride.li8 分钟前
第03章 Python 教程-基础语法:注释与变量
服务器·前端·后端·python·算法·计算机视觉
省钱兄--zs11 分钟前
深圳24小时自助健身房软硬件解决方案实战指南与开发流程详解
java·数据仓库·spring boot·小程序·架构
顽疲29 分钟前
Java vue 养老系统源码详解:月账单 care_month_bill 与 Quartz 扣费 Job 实践
java·开发语言·vue.js·vue养老·springboot养老·java养老
Wang's Blog37 分钟前
Java 项目实战: 交友项目 - 安装开发工具与环境准备
java·开发语言·交友
用户212968352616843 分钟前
开源了一个 Java 多智能体 LLM 框架 Baton:一个依赖,把 Agent 循环、工具调用、记忆、编排全配齐
java·llm
旺仔仔仔1 小时前
机器人项目实战(5):从单次抓取,到接收指令连续做事
算法
helmsail1 小时前
05 管理活动与选品
java
旺仔仔仔1 小时前
机器人项目实战(2):识别物体、提取点云,再到抓取姿态
算法
姜鱼问生1 小时前
密码明明一样,为什么 GPG 说“错的“?
后端·算法·架构
天远数科1 小时前
Java数据工程:利用天远人车核验加强版优化智慧高速ETC发行合规体验
java·人工智能